/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.106 by edhill, Thu Oct 14 03:24:14 2004 UTC revision 1.164 by ce107, Tue Jul 31 22:27:01 2007 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 122  EOF Line 130  EOF
130        stop        stop
131        end        end
132  EOF  EOF
133      test -f Makefile  &&  mv -f Makefile Makefile.bak      test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
134      cat <<EOF >> Makefile      cat <<EOF >> $MAKEFILE
135  .SUFFIXES:  .SUFFIXES:
136  .SUFFIXES: .$tfs .F  .SUFFIXES: .$tfs .F
137  .F.$tfs:  .F.$tfs:
# Line 148  EOF Line 156  EOF
156              return              return
157          fi          fi
158      fi      fi
159      rm -f genmake_hello.* Makefile      rm -f genmake_hello.* $MAKEFILE
160      test -f Makefile  &&  mv -f Makefile.bak Makefile      test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
161    
162      #  If we make it here, use the extensions      #  If we make it here, use the extensions
163      FS=$tfs      FS=$tfs
# Line 181  look_for_makedepend()  { Line 189  look_for_makedepend()  {
189      if test "x${MAKEDEPEND}" = x ; then      if test "x${MAKEDEPEND}" = x ; then
190          which makedepend > /dev/null 2>&1          which makedepend > /dev/null 2>&1
191          RV0=$?          RV0=$?
192            test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
193            #  echo 'MAKEFILE="'$MAKEFILE'"'
194            cat <<EOF >> $MAKEFILE
195    #   THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
196    #
197    #   Some "makedepend" implementations will die if they cannot
198    #   find a Makefile -- so this file is here to gives them an
199    #   empty one to find and parse.
200    EOF
201          cat <<EOF >> genmake_tc.f          cat <<EOF >> genmake_tc.f
202        program test        program test
203        write(*,*) 'test'        write(*,*) 'test'
# Line 189  look_for_makedepend()  { Line 206  look_for_makedepend()  {
206  EOF  EOF
207          makedepend genmake_tc.f > /dev/null 2>&1          makedepend genmake_tc.f > /dev/null 2>&1
208          RV1=$?          RV1=$?
209            test -f $MAKEFILE  &&  rm -f $MAKEFILE
210            test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
211          if test "x${RV0}${RV1}" = x00 ; then          if test "x${RV0}${RV1}" = x00 ; then
212              MAKEDEPEND=makedepend              MAKEDEPEND=makedepend
213          else          else
# Line 237  build_cyrus_makedepend()  { Line 256  build_cyrus_makedepend()  {
256      fi      fi
257  }  }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 271  find_possible_configs()  { Line 325  find_possible_configs()  {
325    
326      #================================================================      #================================================================
327      #  look for possible C compilers      #  look for possible C compilers
328      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      p_CC=      p_CC=
330      for c in $tmp ; do      for c in $tmp ; do
331          rm -f ./genmake_hello.c  ./genmake_hello          rm -f ./genmake_hello.c  ./genmake_hello
# Line 310  EOF Line 364  EOF
364    
365      #================================================================      #================================================================
366      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
367      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 342  EOF Line 396  EOF
396      else      else
397          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
398          echo "   "$p_FC          echo "   "$p_FC
399          if test "x$FC" = x ; then      fi
400              FC=`echo $p_FC | $AWK '{print $1}'`  
401              echo "  Setting FORTRAN compiler to: "$FC      #  Use the first of the compilers found in the current PATH
402          fi      #  that has a correctly-named optfile
403        if test "x$OPTFILE" = x  -a  "x$FC" = x ; then
404            for i in $p_FC ; do
405                OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406                if test -r $OPTFILE ; then
407                    echo "  Setting OPTFILE to: "$OPTFILE
408                    break
409                fi
410            done
411      fi      fi
412    
413      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
# Line 516  Usage: "$0" [OPTIONS] Line 578  Usage: "$0" [OPTIONS]
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587        -ts | --ts
588              Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593        -foolad | --foolad
594              Fool the AD code generator
595        -papi | --papi
596              Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599        -hpmt | --hpmt
600              Performance analysis with the HPM Toolkit
601    
602        -gsl | --gsl
603              Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
609      -mpi=PATH | --mpi=PATH      -mpi=PATH | --mpi=PATH
# Line 523  Usage: "$0" [OPTIONS] Line 611  Usage: "$0" [OPTIONS]
611            set to PATH. i.e. Include files from \$PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
612            from \$PATH/lib and use binaries from \$PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
613    
614        -es | --es | -embed-source | --embed-source
615              Embed a tarball containing the full source code
616              (including the Makefile, etc.) used to build the
617              executable [off by default]
618    
619      -bash NAME      -bash NAME
620            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
621    
# Line 581  WARNING: Please contact <MITgcm-support@ Line 674  WARNING: Please contact <MITgcm-support@
674  EOF  EOF
675          return 1          return 1
676      fi      fi
677      cat > genmake_tcomp.f <<EOF      cat > genmake_tcomp.$FS <<EOF
678        subroutine tcall( string )        subroutine tcall( string )
679        character*(*) string        character*(*) string
680        call tsub( string )        call tsub( string )
681        end        end
682  EOF  EOF
683      $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1      $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
684      RETVAL=$?      RETVAL=$?
685      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
686          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 653  void FC_NAMEMANGLE(cloc) ( double *curti Line 746  void FC_NAMEMANGLE(cloc) ( double *curti
746   *curtim = *curtim/1.E6;   *curtim = *curtim/1.E6;
747  }  }
748  EOF  EOF
749      make genmake_tc_1.o >> genmake_tc.log 2>&1      make genmake_tc_1.o >> genmake_warnings 2>&1
750      RET_C=$?      RET_C=$?
751      cat <<EOF > genmake_tc_2.f      cat <<EOF > genmake_tc_2.$FS
752        program hello        program hello
753        Real*8 wtime        REAL*8 wtime
754        external cloc        external cloc
755        call cloc(wtime)        call cloc(wtime)
756        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
757        end program hello        end
758  EOF  EOF
759      $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
760        echo $COMM >> genmake_warnings
761        $COMM >> genmake_warnings 2>&1
762      RET_F=$?      RET_F=$?
763      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
764      RETVAL=$?      RETVAL=$?
765      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
766          HAVE_CLOC=t          HAVE_CLOC=t
# Line 675  EOF Line 770  EOF
770  }  }
771    
772    
773    check_HAVE_SIGREG()  {
774        if test ! "x$HAVE_SIGREG" = x ; then
775            return
776        fi
777        get_fortran_c_namemangling
778        cat <<EOF > genmake_tc_1.c
779    $FC_NAMEMANGLE
780    #include <stdlib.h>
781    #include <stdio.h>
782    #include <signal.h>
783    #include <errno.h>
784    #include <ucontext.h>
785    
786    int * ip;
787    
788    static void killhandler(
789        unsigned int sn, siginfo_t  si, struct ucontext *sc )
790    {
791        *ip = *ip + 1;
792        return;
793    }
794    
795    void FC_NAMEMANGLE(sigreg) (int * aip)
796    {
797        struct sigaction s;
798        ip = aip;
799        s.sa_flags = SA_SIGINFO;
800        s.sa_sigaction = (void *)killhandler;
801        if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
802            printf("Sigaction returned error = %d\n", errno);
803            exit(0);
804        }
805        return;
806    }
807    EOF
808        make genmake_tc_1.o >> genmake_warnings 2>&1
809        RET_C=$?
810        cat <<EOF > genmake_tc_2.$FS
811          program hello
812          integer anint
813          common /iv/ anint
814          external sigreg
815          call sigreg(anint)
816          end
817    EOF
818        echo >> genmake_warnings
819        echo "running: check_HAVE_SIGREG()" >> genmake_warnings
820        cat genmake_tc_2.$FS >> genmake_warnings
821        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
822        echo $COMM >> genmake_warnings
823        $COMM >> genmake_warnings 2>&1
824        RETVAL=$?
825        if test "x$RETVAL" = x0 ; then
826            HAVE_SIGREG=t
827            DEFINES="$DEFINES -DHAVE_SIGREG"
828        fi
829        rm -f genmake_tc*
830    }
831    
832    
833    check_HAVE_SETRLSTK()  {
834        if test "x$HAVE_SETRLSTK" = xt ; then
835            DEFINES="$DEFINES -DHAVE_SETRLSTK"
836            return
837        fi  
838        if test ! "x$HAVE_SETRLSTK" = x ; then
839            return
840        fi
841        get_fortran_c_namemangling
842        cat <<EOF > genmake_tc_1.c
843    $FC_NAMEMANGLE
844    #include <sys/time.h>
845    #include <sys/resource.h>
846    #include <unistd.h>
847    void FC_NAMEMANGLE(setrlstk) ()
848    {
849        struct rlimit rls;
850        rls.rlim_cur = RLIM_INFINITY;
851        rls.rlim_max = RLIM_INFINITY;
852        setrlimit(RLIMIT_STACK, &rls);
853        return;
854    }
855    EOF
856        make genmake_tc_1.o >> genmake_warnings 2>&1
857        RET_C=$?
858        cat <<EOF > genmake_tc_2.$FS
859          program hello
860          external setrlstk
861          call setrlstk()
862          end
863    EOF
864        echo >> genmake_warnings
865        echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
866        cat genmake_tc_2.$FS >> genmake_warnings
867        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
868        echo $COMM >> genmake_warnings
869        $COMM >> genmake_warnings 2>&1
870        RETVAL=$?
871        if test "x$RETVAL" = x0 ; then
872            HAVE_SETRLSTK=t
873            DEFINES="$DEFINES -DHAVE_SETRLSTK"
874        fi
875        rm -f genmake_tc*
876    }
877    
878    
879    check_HAVE_STAT()  {
880        get_fortran_c_namemangling
881        cat <<EOF > genmake_tc_1.c
882    $FC_NAMEMANGLE
883    #include <stdio.h>
884    #include <stdlib.h>
885    #include <unistd.h>
886    #include <sys/stat.h>
887    #include <sys/types.h>
888    void FC_NAMEMANGLE(tfsize) ( int *nbyte )
889    {
890        char name[512];
891        struct stat astat;
892    
893        name[0] = 'a'; name[1] = '\0';
894        if (! stat(name, &astat))
895            *nbyte = (int)(astat.st_size);
896        else
897            *nbyte = -1;
898    }
899    EOF
900        make genmake_tc_1.o >> genmake_tc.log 2>&1
901        RET_C=$?
902        cat <<EOF > genmake_tc_2.$FS
903          program hello
904          integer nbyte
905          call tfsize(nbyte)
906          print *," HELLO WORLD", nbyte
907          end
908    EOF
909        echo >> genmake_warnings
910        echo "running: check_HAVE_STAT()" >> genmake_warnings
911        cat genmake_tc_2.$FS >> genmake_warnings
912        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
913        echo $COMM >> genmake_warnings
914        $COMM >> genmake_tc.log 2>&1
915        RETVAL=$?
916        if test "x$RETVAL" = x0 ; then
917            HAVE_STAT=t
918            DEFINES="$DEFINES -DHAVE_STAT"
919        fi
920        rm -f genmake_tc*
921    }
922    
923    
924  check_netcdf_libs()  {  check_netcdf_libs()  {
925      echo "" > genmake_tnc.log      if test ! "x$SKIP_NETCDF_CHECK" = x ; then
926      cat <<EOF > genmake_tnc.for          return
927        fi
928        echo >> genmake_warnings
929        echo "running: check_netcdf_libs()" >> genmake_warnings
930        cat <<EOF > genmake_tnc.F
931        program fgennc        program fgennc
932  #include "netcdf.inc"  #include "netcdf.inc"
933    EOF
934        if test ! "x$MPI" = x ; then
935            echo '#include "mpif.h"' >> genmake_tnc.F
936        fi
937        cat <<EOF >> genmake_tnc.F
938        integer iret, ncid, xid        integer iret, ncid, xid
939        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
940        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
# Line 689  check_netcdf_libs()  { Line 944  check_netcdf_libs()  {
944        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
945        end        end
946  EOF  EOF
947      #echo "$CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f"      echo "===  genmake_tnc.F  ===" > genmake_tnc.log
948      #echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.f"      cat genmake_tnc.F >> genmake_tnc.log
949      #echo "$LINK -o genmake_tnc.o $LIBS"      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
950      $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \      RET_CPP=f
951          &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
952          &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1      echo "$COMM" >> genmake_tnc.log
953        eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
954        if test "x$RET_CPP" = xf ; then
955            echo "  WARNING: CPP failed to pre-process the netcdf test." \
956                >> genmake_tnc.log
957            echo "    Please check that \$INCLUDES is properly set." \
958                >> genmake_tnc.log
959        fi
960        echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
961        echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
962        $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
963            &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
964      RET_COMPILE=$?      RET_COMPILE=$?
965        cat genmake_tnc.log >> genmake_warnings
966    
967      #EH3  Remove test program execution for machines that either disallow      #EH3  Remove test program execution for machines that either disallow
968      #EH3  execution or cannot support it (eg. cross-compilers)      #EH3  execution or cannot support it (eg. cross-compilers)
# Line 708  EOF Line 975  EOF
975          HAVE_NETCDF=t          HAVE_NETCDF=t
976      else      else
977          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
978          $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \          echo "try again with added '-lnetcdf'" > genmake_tnc.log
979              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
980              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
981            echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
982            cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
983                &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
984                &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
985          RET_COMPILE=$?          RET_COMPILE=$?
986            cat genmake_tnc.log >> genmake_warnings
987          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
988              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
989              HAVE_NETCDF=t              HAVE_NETCDF=t
990          else          else
991            # try again with "-lnetcdff" added to the libs
992                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
993                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
994                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
995                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
996                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
997                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
998                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
999                RET_COMPILE=$?
1000              cat genmake_tnc.log >> genmake_warnings              cat genmake_tnc.log >> genmake_warnings
1001                if test "x$RET_COMPILE" = x0 ; then
1002                    LIBS="$LIBS -lnetcdff -lnetcdf"
1003                    HAVE_NETCDF=t
1004                fi
1005          fi          fi
1006      fi      fi
1007      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 735  PLATFORM= Line 1020  PLATFORM=
1020  LN=  LN=
1021  S64=  S64=
1022  KPP=  KPP=
1023  FC=  #FC=
1024  #CC=gcc  #CC=gcc
1025  CPP=  #CPP=
1026  LINK=  LINK=
1027  DEFINES=  DEFINES=
1028  PACKAGES=  PACKAGES=
1029  ENABLE=  ENABLE=
1030  DISABLE=  DISABLE=
1031  MAKEFILE=  # MAKEFILE=
1032  #MAKEDEPEND=  # MAKEDEPEND=
1033  PDEPEND=  PDEPEND=
1034  DUMPSTATE=t  DUMPSTATE=t
1035  PDEFAULT=  PDEFAULT=
1036  OPTFILE=  OPTFILE=
1037  INCLUDES="-I."  INCLUDES="-I. $INCLUDES"
1038  FFLAGS=  FFLAGS=
1039  FOPTIM=  FOPTIM=
1040  CFLAGS=  CFLAGS=
# Line 762  NOOPTFILES= Line 1047  NOOPTFILES=
1047  NOOPTFLAGS=  NOOPTFLAGS=
1048  MPI=  MPI=
1049  MPIPATH=  MPIPATH=
1050    TS=
1051    PAPIS=
1052    PCLS=
1053    FOOLAD=
1054    PAPI=
1055    PCL=
1056    HPMT=
1057    GSL=
1058    DEVEL=
1059    HAVE_TEST_L=
1060    
1061  # DEFINES checked by test compilation  # DEFINES checked by test compilation or command-line
1062  HAVE_SYSTEM=  HAVE_SYSTEM=
1063  HAVE_FDATE=  HAVE_FDATE=
1064  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1065  HAVE_CLOC=  HAVE_CLOC=
1066    # HAVE_SETRLSTK=
1067    HAVE_STAT=
1068  HAVE_NETCDF=  HAVE_NETCDF=
1069  HAVE_ETIME=  HAVE_ETIME=
1070    IGNORE_TIME=
1071    
1072  MODS=  MODS=
1073  TOOLSDIR=  TOOLSDIR=
# Line 780  STANDARDDIRS="USE_THE_DEFAULT" Line 1078  STANDARDDIRS="USE_THE_DEFAULT"
1078  G2ARGS=  G2ARGS=
1079  BASH=  BASH=
1080  PWD=`pwd`  PWD=`pwd`
1081  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1082  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1083    EMBED_SRC=
1084  THISHOST=`hostname`  THISHOST=`hostname`
1085  THISCWD=`pwd`  THISCWD=`pwd`
1086  THISDATE=`date`  THISDATE=`date`
# Line 815  TAMC_EXTRA= Line 1114  TAMC_EXTRA=
1114    
1115  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1116  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1117  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1118    
1119  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1120  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 995  for ac_option in "$@" ; do Line 1294  for ac_option in "$@" ; do
1294          -noieee | --noieee)          -noieee | --noieee)
1295              IEEE= ;;              IEEE= ;;
1296    
1297            -ts | --ts)
1298                TS=true ;;
1299            -papis | --papis)
1300                PAPIS=true ;;
1301            -pcls | --pcls)
1302                PCLS=true ;;
1303            -foolad | --foolad)
1304                FOOLAD=true ;;
1305            -papi | --papi)
1306                PAPI=true ;;
1307            -pcl | --pcl)
1308                PCL=true ;;
1309            -hpmt | --hpmt)
1310                HPMT=true ;;
1311    
1312            -gsl | --gsl)
1313                GSL=true ;;
1314    
1315            -devel | --devel)
1316                DEVEL=true ;;
1317    
1318          -mpi | --mpi)          -mpi | --mpi)
1319              MPI=true ;;              MPI=true ;;
1320          -mpi=* | --mpi=*)          -mpi=* | --mpi=*)
# Line 1018  for ac_option in "$@" ; do Line 1338  for ac_option in "$@" ; do
1338              ac_prev=TAMC_EXTRA ;;              ac_prev=TAMC_EXTRA ;;
1339          -tamc_extra=* | --tamc_extra=*)          -tamc_extra=* | --tamc_extra=*)
1340              TAMC_EXTRA=$ac_optarg ;;              TAMC_EXTRA=$ac_optarg ;;
1341            
1342            -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1343                IGNORE_TIME="-DIGNORE_TIME" ;;
1344    
1345            -es | --es | -embed-source | --embed-source)
1346                EMBED_SRC=t ;;
1347    
1348          -*)          -*)
1349              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
# Line 1033  for ac_option in "$@" ; do Line 1359  for ac_option in "$@" ; do
1359            
1360  done  done
1361    
1362    
1363  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1364      echo      echo
1365      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1366      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1367      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1368      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1369      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1370      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1371      echo      echo
1372  fi  fi
1373    
1374  #  Find the MITgcm ${ROOTDIR}  #  Find the MITgcm ${ROOTDIR}
1375  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1376      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1377      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1378          ROOTDIR=".."          ROOTDIR=".."
1379      else      else
1380          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 1074  fi Line 1400  fi
1400    
1401  #  Find the MITgcm ${THISVER}  #  Find the MITgcm ${THISVER}
1402  if test -f "${ROOTDIR}/doc/tag-index" ; then  if test -f "${ROOTDIR}/doc/tag-index" ; then
1403      THISVER=`grep checkpoint ${ROOTDIR}/doc/tag-index | head -1`      THISVER=`grep '^checkpoint' ${ROOTDIR}/doc/tag-index | head -1`
1404    fi
1405    
1406    if test "x$MAKEFILE" = x ; then
1407        MAKEFILE="Makefile"
1408  fi  fi
1409    
1410  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
# Line 1106  if test "x$OPTFILE" != xNONE ; then Line 1436  if test "x$OPTFILE" != xNONE ; then
1436      fi      fi
1437  fi  fi
1438    
 #  Check for broken systems that cannot correctly distinguish *.F and *.f files  
 # check_for_broken_Ff  
   
1439  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1440  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1441      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 1136  if test "x${AD_OPTFILE}" != xNONE ; then Line 1463  if test "x${AD_OPTFILE}" != xNONE ; then
1463      fi      fi
1464  fi  fi
1465    
1466    #====================================================================
1467    #  Set default values if not set by the optfile
1468    #
1469  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1470  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1471  if test ! "x$BASH" = x ; then  if test ! "x$BASH" = x ; then
# Line 1212  Error: The command "ln -s" failed -- ple Line 1542  Error: The command "ln -s" failed -- ple
1542  EOF  EOF
1543      exit 1      exit 1
1544  fi  fi
1545    test -L genmake_tlink > /dev/null 2>&1
1546    RETVAL=$?
1547    if test "x$RETVAL" = x0 ; then
1548        HAVE_TEST_L=t
1549    fi
1550  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1551    
1552  #  Check for broken *.F/*.f handling and fix if possible  #  Check for broken *.F/*.f handling and fix if possible
# Line 1222  if test ! "x$MPI" = x ; then Line 1557  if test ! "x$MPI" = x ; then
1557        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1558  fi  fi
1559    
1560    if test ! "x$TS" = x ; then
1561          echo "  Turning on timing per timestep"
1562          if test ! "x$FOOLAD" = x ; then
1563                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1564          else
1565                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1566          fi
1567          PACKAGES="$PACKAGES showflops"
1568    fi
1569    if test ! "x$PAPIS" = x ; then
1570          echo "  Turning on PAPI flop summary per timestep"
1571          echo "  Please make sure PAPIINC, PAPILIB are defined"
1572          if test ! "x$FOOLAD" = x ; then
1573                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1574          else
1575                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1576          fi
1577          INCLUDES="$INCLUDES $PAPIINC"
1578          LIBS="$LIBS $PAPILIB"
1579          PACKAGES="$PACKAGES showflops"
1580    fi
1581    if test ! "x$PCLS" = x ; then
1582          echo "  Turning on PCL counter summary per timestep"
1583          echo "  Please make sure PCLINC, PCLLIB are defined"
1584          if test ! "x$FOOLAD" = x ; then
1585                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1586          else
1587                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1588          fi
1589          INCLUDES="$INCLUDES $PCLINC"
1590          LIBS="$LIBS $PCLLIB"
1591          PACKAGES="$PACKAGES showflops"
1592    fi
1593    if test ! "x$PAPI" = x ; then
1594          if test ! "x$PAPIS" = x ; then
1595              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1596              echo "  Sticking with PAPI flop summary per timestep!"
1597          else
1598              echo "  Turning on performance analysis with PAPI"
1599              echo "  Please make sure PAPIINC, PAPILIB are defined"
1600              DEFINES="$DEFINES -DUSE_PAPI"
1601              INCLUDES="$INCLUDES $PAPIINC"
1602              LIBS="$LIBS $PAPILIB"
1603          fi
1604    fi
1605    if test ! "x$PCL" = x ; then
1606          if test ! "x$PCLS" = x ; then
1607              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1608              echo "  Sticking with PCL flop summary per timestep!"
1609          else
1610              echo "  Turning on performance analysis with PCL"
1611              echo "  Please make sure PCLINC, PCLLIB are defined"
1612              DEFINES="$DEFINES -DUSE_PCL"
1613              INCLUDES="$INCLUDES $PCLINC"
1614              LIBS="$LIBS $PCLLIB"
1615          fi
1616    fi
1617    if test ! "x$HPMT" = x ; then
1618          if test ! "x$PAPI" = x ; then
1619              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1620              echo "  Sticking with PAPI!"
1621          else if test ! "x$PCL" = x ; then
1622              echo "  PCL and the HPM Toolkit cannot co-exist!"
1623              echo "  Sticking with PCL!"
1624          else
1625              echo "  Turning on performance analysis with the HPM Toolkit"
1626              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1627              DEFINES="$DEFINES -DUSE_LIBHPM"
1628              INCLUDES="$INCLUDES $HPMTINC"
1629              LIBS="$LIBS $HPMTLIB"
1630          fi
1631          fi
1632    fi
1633    if test ! "x$GSL" = x ; then
1634          echo "  Turning on use of GSL to control floating point calculations"
1635          echo "  Please make sure GSLINC, GSLLIB are defined"
1636          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1637          INCLUDES="$INCLUDES $GSLINC"
1638          LIBS="$LIBS $GSLLIB"
1639    fi
1640    
1641  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1642  printf "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1643  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1644        program hello        program hello
1645        call system('echo hi')        call system('echo hi')
1646        end        end
1647  EOF  EOF
1648  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1649  RETVAL=$?  RETVAL=$?
1650  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1651      HAVE_SYSTEM=t      HAVE_SYSTEM=t
# Line 1242  fi Line 1658  fi
1658  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1659    
1660  printf "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1661  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1662        program hello        program hello
1663        CHARACTER(128) string        CHARACTER*(128) string
1664        string = ' '        string = ' '
1665        call fdate( string )        call fdate( string )
1666        print *, string        print *, string
1667        end        end
1668  EOF  EOF
1669  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1670  RETVAL=$?  RETVAL=$?
1671  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1672      HAVE_FDATE=t      HAVE_FDATE=t
# Line 1263  fi Line 1679  fi
1679  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1680    
1681  printf "  Do we have the etime() command using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1682  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1683        program hello        program hello
1684        REAL*4 ACTUAL, TARRAY(2)        REAL*4 ACTUAL, TARRAY(2)
1685        EXTERNAL ETIME        EXTERNAL ETIME
# Line 1272  cat > genmake_tcomp.f <<EOF Line 1688  cat > genmake_tcomp.f <<EOF
1688        print *, tarray        print *, tarray
1689        end        end
1690  EOF  EOF
1691  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1692  RETVAL=$?  RETVAL=$?
1693  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1694      HAVE_ETIME=t      HAVE_ETIME=t
# Line 1290  if test "x$HAVE_CLOC" != x ; then Line 1706  if test "x$HAVE_CLOC" != x ; then
1706      echo "yes"      echo "yes"
1707  else  else
1708      echo "no"      echo "no"
1709        if test "x$EMBED_SRC" = xt ; then
1710            echo "    WARNING: you requested file embedding but it has"
1711            echo "      been disabled since C code cannot be called"
1712            EMBED_SRC=
1713        fi
1714    fi
1715    rm -f genmake_t*
1716    
1717    printf "  Can we unlimit the stack size using $FC...  "
1718    check_HAVE_SETRLSTK
1719    if test "x$HAVE_SETRLSTK" = xt ; then
1720        echo "yes"
1721    else
1722        echo "no"
1723    fi
1724    rm -f genmake_t*
1725    
1726    printf "  Can we register a signal handler using $FC...  "
1727    check_HAVE_SIGREG
1728    if test "x$HAVE_SIGREG" = xt ; then
1729        echo "yes"
1730    else
1731        echo "no"
1732    fi
1733    rm -f genmake_t*
1734    
1735    printf "  Can we use stat() through C calls...  "
1736    check_HAVE_STAT
1737    if test "x$HAVE_STAT" != x ; then
1738        echo "yes"
1739    else
1740        echo "no"
1741  fi  fi
1742  rm -f genmake_t*  rm -f genmake_t*
1743    
# Line 1300  if test "x$HAVE_NETCDF" != x ; then Line 1748  if test "x$HAVE_NETCDF" != x ; then
1748  else  else
1749      echo "no"      echo "no"
1750  fi  fi
1751    DEFINES="$DEFINES $IGNORE_TIME"
1752    
1753    if test "x$EMBED_SRC" = xt ; then
1754        build_embed_encode
1755    fi
1756    if test "x$EMBED_SRC" = xt ; then
1757        ENABLE="$ENABLE embed_files"
1758    fi
1759    
1760    
1761  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
# Line 1317  for d in $MODS ; do Line 1773  for d in $MODS ; do
1773  done  done
1774  echo  echo
1775    
 if test "x$MAKEFILE" = x ; then  
     MAKEFILE="Makefile"  
 fi  
1776  if test "x${PLATFORM}" = x ; then  if test "x${PLATFORM}" = x ; then
1777      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
1778  fi  fi
1779    
1780  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1781      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1782      if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then      if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1783          EXEDIR=../exe          EXEDIR=../exe
1784      else      else
# Line 1390  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1843  if test -r $ROOTDIR"/eesupp/src/Makefile
1843      fi      fi
1844  fi  fi
1845    
1846  #same for exch2  #same for pkg/exch2 and pkg/regrid
1847  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1848      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1849      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1850      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1851      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1852          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1853      else              rm -f make_${pdir}.errors
1854          echo "Error: problem encountered while building source files in exch2:"          else
1855          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1856          exit 1              cat make_${pdir}.errors 1>&2
1857                exit 1
1858            fi
1859      fi      fi
1860  fi  done
1861    
1862  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1863  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1513  done Line 1968  done
1968  rm -f ./.tmp_pack  rm -f ./.tmp_pack
1969  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1970    
1971  #  Check availability of NetCDF and then either build the MNC template  #  Check for package MNC: if NetCDF is available, then build the MNC
1972  #  files or delete mnc from the list of available packages.  #  template files ; otherwise, delete mnc from the list of packages.
1973  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1974  RETVAL=$?  RETVAL=$?
1975  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
# Line 1536  EOF Line 1991  EOF
1991          PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`          PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1992          DISABLE="$DISABLE mnc"          DISABLE="$DISABLE mnc"
1993      else      else
1994          ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1          ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
1995          RETVAL=$?          RETVAL=$?
1996          if test "x${RETVAL}" = x0 ; then          if test "x${RETVAL}" = x0 ; then
1997              rm -f make_mnc.errors              rm -f make_mnc.errors
# Line 1548  EOF Line 2003  EOF
2003      fi      fi
2004  fi  fi
2005    
2006    #  Check for package PROFILES: if NetCDF is not available,
2007    #  then delete profiles from the list of available packages.
2008    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2009    RETVAL=$?
2010    if test "x$RETVAL" = x0 ; then
2011        if test "x$HAVE_NETCDF" != xt ; then
2012            cat <<EOF
2013    
2014    *********************************************************************
2015    WARNING: the "profiles" package was enabled but tests failed to
2016      compile NetCDF applications.  Please check that:
2017    
2018      1) NetCDF is correctly installed for this compiler and
2019      2) the LIBS variable (within the "optfile") specifies the correct
2020           NetCDF library to link against.
2021    
2022      Due to this failure, the "profiles" package is now DISABLED.
2023    *********************************************************************
2024    
2025    EOF
2026            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2027            DISABLE="$DISABLE profiles"
2028        fi
2029    fi
2030    
2031  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2032  ck=  ck=
2033  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
2034      i=0      i=0
2035      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2036      rtot=$nname      rtot=$nname
2037      while test $i -lt $rtot ; do      while test $i -le $rtot ; do
2038    
2039          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
2040          #  pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
# Line 1588  while test "x$ck" != xtt ; do Line 2068  while test "x$ck" != xtt ; do
2068    
2069          #  Do we need to add $dname according to the dependency rules?          #  Do we need to add $dname according to the dependency rules?
2070          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2071                #echo "   " $pname ": need to add :" $dname
2072              in_dis="f"              in_dis="f"
2073              for dis in $DISABLE ; do              for dis in $DISABLE ; do
2074                  if test "x$dis" = "x$dname" ; then                  if test "x$dis" = "x$dname" ; then
# Line 1651  for n in $names ; do Line 2132  for n in $names ; do
2132              fi              fi
2133          done          done
2134          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
2135              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2136              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
2137          fi          fi
2138      fi      fi
2139  done  done
2140  ENABLED_PACKAGES=  ENABLED_PACKAGES=
2141  for i in $PACKAGES ; do  for i in $PACKAGES ; do
2142      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2143      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
2144  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
2145    
# Line 1742  for i in $SOURCEDIRS ; do Line 2223  for i in $SOURCEDIRS ; do
2223          cat $i/$j >> ad_files          cat $i/$j >> ad_files
2224      done      done
2225  done  done
2226    if test ! "x"$FS = "x.f" ; then
2227        cat ad_files | sed -e "s/\.f/.$FS/g" > ad_files_f
2228        mv -f ad_files_f ad_files
2229    fi
2230    
2231  echo  echo
2232  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1753  for i in $INCLUDEDIRS ; do Line 2237  for i in $INCLUDEDIRS ; do
2237      fi      fi
2238  done  done
2239    
2240    if test ! "x$DIVA" = x ; then
2241        echo "  Creating the pseudo-MPI include directory"
2242        INCLUDES="-I./mpi_headers $INCLUDES"
2243        rm -rf ./mpi_headers
2244        mkdir -p ./mpi_headers
2245    
2246        if test "x$MPIINCLUDEDIR" = x ; then
2247            if test "x$MPIHOME" = x ; then
2248                MPIHOME='/usr'
2249            fi
2250            MPIINCLUDEDIR='$MPIHOME/include'
2251        fi
2252        
2253        if test -r $MPIINCLUDEDIR/mpif.h ; then
2254            for i in $MPI_HEADER_FILES; do
2255                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2256            done
2257    
2258            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2259        else
2260            echo " We cannot create a copy of mpif.h!"
2261    #       exit -1
2262        fi
2263    fi
2264    
2265  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2266  rm -rf .links.tmp  rm -rf .links.tmp
2267  mkdir .links.tmp  mkdir .links.tmp
2268    touch .links.tmp/foo
2269    if test ! -r ".links.tmp/foo" ; then
2270        echo
2271        echo "ERROR : something is wrong with your directory permissions or"
2272        echo "   your user file-creation mask (\"umask\") since creating a"
2273        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2274        echo "   not working.  Please try setting your umask to something"
2275        echo "   sane such as:"
2276        echo
2277        echo "      umask 0002"
2278        echo
2279        echo "   and please verify that you have the proper permissions for"
2280        echo "   creating sub-directories and then reading files created"
2281        echo "   within them."
2282        echo
2283        exit 1
2284    fi
2285    rm -f .links.tmp/foo
2286  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2287  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2288  printf 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
# Line 1771  for d in $alldirs ; do Line 2298  for d in $alldirs ; do
2298      for sf in $sfiles ; do      for sf in $sfiles ; do
2299          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
2300              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
2301                    ignore_f=f
2302                  case $d/$sf in                  case $d/$sf in
2303                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2304                            ignore_f=t
2305                          ;;                          ;;
2306                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2307                            ignore_f=t
2308                          ;;                          ;;
2309                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2310                            ignore_f=t
2311                          ;;                          ;;
2312                    ./BUILD_INFO.h)                    ./BUILD_INFO.h)
2313                            ignore_f=t
2314                            ;;
2315                      ./EMBEDDED_FILES.h)
2316                            ignore_f=t
2317                          ;;                          ;;
2318                    *)                    *)
2319                          touch .links.tmp/$sf                          #  For the local directory *ONLY*,
2320                          deplist="$deplist $sf"                          #  ignore all soft-links
2321                            if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2322                                ignore_f=t
2323                            else
2324                                touch .links.tmp/$sf
2325                                deplist="$deplist $sf"
2326                            fi
2327                          ;;                          ;;
2328                  esac                  esac
2329                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  if test "x$ignore_f" = xf ; then
2330                  case $extn in                      extn=`echo $sf | $AWK -F. '{print $NF}'`
2331                      F)                      case $extn in
2332                          echo    " \\"  >> srclist.inc                          F)
2333                          printf " $sf" >> srclist.inc                              echo    " \\"  >> srclist.inc
2334                          ;;                              printf " $sf" >> srclist.inc
2335                      F90)                              ;;
2336                          echo    " \\"  >> f90srclist.inc                          F90)
2337                          printf " $sf" >> f90srclist.inc                              echo    " \\"  >> f90srclist.inc
2338                          ;;                              printf " $sf" >> f90srclist.inc
2339                      c)                              ;;
2340                          echo    " \\"  >> csrclist.inc                          c)
2341                          printf " $sf" >> csrclist.inc                              echo    " \\"  >> csrclist.inc
2342                          ;;                              printf " $sf" >> csrclist.inc
2343                      h)                              ;;
2344                          echo    " \\"  >> hlist.inc                          h)
2345                          printf " $sf" >> hlist.inc                              echo    " \\"  >> hlist.inc
2346                          ;;                              printf " $sf" >> hlist.inc
2347                      flow)                              ;;
2348                          echo    " \\"  >> ad_flow_files.inc                          flow)
2349                          printf " $sf" >> ad_flow_files.inc                              echo    " \\"  >> ad_flow_files.inc
2350                          ;;                              printf " $sf" >> ad_flow_files.inc
2351                  esac                              ;;
2352                        esac
2353                    fi
2354              fi              fi
2355          fi          fi
2356      done      done
# Line 1883  DISABLED_PACKAGES = ${DISABLED_PACKAGES} Line 2426  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2426    
2427  # These files are created by Makefile  # These files are created by Makefile
2428  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2429  EOF  EOF
2430    
2431  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2432        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2433    else
2434        echo "EMBEDDED_FILES = " >>$MAKEFILE
2435    fi
2436    
2437    #  Note: figure out some way to add Hyades JAM libraries here
2438  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2439  # Unix ln (link)  # Unix ln (link)
2440  LN = ${LN}  LN = ${LN}
# Line 1925  CFLAGS = ${CFLAGS} Line 2472  CFLAGS = ${CFLAGS}
2472  NOOPTFILES = ${NOOPTFILES}  NOOPTFILES = ${NOOPTFILES}
2473  NOOPTFLAGS = ${NOOPTFLAGS}  NOOPTFLAGS = ${NOOPTFLAGS}
2474  # Flags and libraries needed for linking  # Flags and libraries needed for linking
2475  LIBS = ${LIBS} \$(XLIBS)  LIBS = ${LIBS}
2476  # Name of the Mekfile  # Name of the Mekfile
2477  MAKEFILE=${MAKEFILE}  MAKEFILE=${MAKEFILE}
2478    
# Line 1938  cat hlist.inc         >> $MAKEFILE Line 2485  cat hlist.inc         >> $MAKEFILE
2485  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
2486  echo >> $MAKEFILE  echo >> $MAKEFILE
2487  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
2488  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE
2489  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2490  echo >> $MAKEFILE  echo >> $MAKEFILE
2491  echo '.SUFFIXES:' >> $MAKEFILE  echo '.SUFFIXES:' >> $MAKEFILE
# Line 1949  rm -f ad_flow_files.inc Line 2496  rm -f ad_flow_files.inc
2496  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2497    
2498  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2499  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2500          @echo Creating \$@ ...          @echo Creating \$@ ...
2501          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2502  depend:  depend:
# Line 1958  depend: Line 2505  depend:
2505          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2506          -rm -f makedepend.out          -rm -f makedepend.out
2507    
2508    lib: libmitgcmuv.a
2509    
2510    libmitgcmuv.a: \$(OBJFILES)
2511            ar rcv libmitgcmuv.a \$(OBJFILES)
2512            ar d   libmitgcmuv.a main.o
2513    
2514  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2515    
2516  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
# Line 1967  output.txt: \$(EXECUTABLE) Line 2520  output.txt: \$(EXECUTABLE)
2520          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2521    
2522  clean:  clean:
2523          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2524            -rm -rf *.o
2525            -rm -rf *.$FS
2526  Clean:  Clean:
2527          @make clean          @make clean
2528          @make cleanlinks          @make cleanlinks
# Line 1978  CLEAN: Line 2533  CLEAN:
2533          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2534          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2535          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2536          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2537            -rm -rf mnc_test_*
2538    
2539  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2540  makefile:  makefile:
# Line 2006  test ! "x$THISUSER" = x && echo "      -echo Line 2562  test ! "x$THISUSER" = x && echo "      -echo
2562  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2563  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2564    
2565    if test "x$EMBED_SRC" = xt ; then
2566        cat >>$MAKEFILE <<EOF
2567    
2568    decode_files.o : EMBEDDED_FILES.h
2569    
2570    ##  \$(F77FILES)
2571    all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2572            @echo Creating \$@ ...
2573            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2574            -rm -f all_fF.tar.gz
2575            -gzip all_fF.tar
2576    
2577    EMBEDDED_FILES.h : all_fF.tar.gz
2578            @echo Creating \$@ ...
2579            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2580    
2581    EOF
2582    fi
2583    
2584  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2585    
2586  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
# Line 2017  cat >>$MAKEFILE <<EOF Line 2592  cat >>$MAKEFILE <<EOF
2592          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2593  .$FS.o:  .$FS.o:
2594          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2595  .F90.$FS90:  .F90.o:  
         \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@  
 .$FS90.o:  
2596          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2597  .c.o:  .c.o:
2598          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2599    
2600  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2601  .F.p:  .F.p:
# Line 2046  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2619  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2619  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2620  for i in $ad_vars ; do  for i in $ad_vars ; do
2621      name=$i      name=$i
2622      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2623      eval $t1      eval $t1
2624      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2625      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2626  done  done
2627    
2628  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
# Line 2066  rm -f ad_files Line 2639  rm -f ad_files
2639  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2640    
2641  # ... AD ...  # ... AD ...
2642  adall: ad_taf  adall: \$(EXE_AD)
2643  adtaf: ad_taf_output.f  adtaf: ad_taf_output.$FS
2644  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.$FS
2645    
2646  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2647          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2648          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2649          -rm -f ad_config.template          -rm -f ad_config.template
2650          @make \$(F77FILES)          @make \$(F77FILES)
2651          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2652          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.$FS
2653    
2654  ad_taf_output.f: ad_input_code.f  ad_taf_output.$FS: ad_input_code.$FS
2655          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2656          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2657    
2658  adtafonly:  adtafonly:
2659          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2660          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2661    
2662  ad_taf: ad_taf_output.o \$(OBJFILES)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2663          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2664    
2665  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.$FS: ad_input_code.$FS
2666          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2667          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2668    
2669  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
2670          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 2104  adtrick: Line 2677  adtrick:
2677    
2678  # ... FTL ...  # ... FTL ...
2679  ftlall: ftl_taf  ftlall: ftl_taf
2680  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.$FS
2681  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.$FS
2682    
2683  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2684          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2685          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2686          -rm -f ftl_config.template          -rm -f ftl_config.template
2687          @make \$(F77FILES)          @make \$(F77FILES)
2688          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2689          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2690    
2691  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.$FS: ftl_input_code.$FS
2692          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2693          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2694    
2695  ftltafonly:  ftltafonly:
2696          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2697          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2698    
2699  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
2700          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2701    
2702  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.$FS: ftl_input_code.$FS
2703          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2704          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2705    
2706  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2707          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2708    
2709    
2710  # ... SVD ...  # ... SVD ...
2711  svdtaf: ad_taf_output.f ftl_taf_output.f  svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2712  svdall: svd_taf          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
2713            @echo "--->>> Do make svdall afterwards to compile. <<<---"
2714    svdall: svd_touch svd_taf
2715    
2716  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)  svd_taf: \$(OBJFILES)
2717          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2718    
2719            @echo "--->>> Only COMPILE svd code! <<<---"
2720            @echo "--->>> Assumes you previously <<<---"
2721            @echo "--->>> did make svdtaf        <<<---"
2722    
2723    svd_touch:
2724            @echo "--->>> Only COMPILE svd code! <<<---"
2725            @echo "--->>> Assumes you previously <<<---"
2726            @echo "--->>> did make svdtaf        <<<---"
2727            touch ad_taf_output.$FS ftl_taf_output.$FS
2728            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2729            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2730            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2731            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2732            -rm -f ftl_config.template
2733    
2734  #=========================================  #=========================================
2735    

Legend:
Removed from v.1.106  
changed lines
  Added in v.1.164

  ViewVC Help
Powered by ViewVC 1.1.22